package dk.aau.cs.model.tapn.Colored;

import java.util.Vector;

public class Color {

    private Vector<Color> tuple;
    private ColorType colorType;
    private String colorName;
    private Integer id;

    public Color(ColorType colorType, Integer id, Vector<Color> colors) {
        this.tuple = colors;
        this.colorType = colorType;
        this.colorName = "";
        this.id = id;

    }

    public Color(ColorType colorType, Integer id, String color) {
        this.tuple = null;
        this.colorType = colorType;
        this.colorName = color;
        this.id = id;
    }


    public String getName() {
        return colorName;
    }

    public String getColorName() {return colorName;}

    public Vector<Color> getTuple() {return tuple;}

    public ColorType getColorType() {
        return colorType;
    }

    public Color successor() {
        return colorType.successorTo(this, 1);
    }

    public Color predecessor() {
        return colorType.successorTo(this, -1);
    }

    @Override
    public String toString() {
        if (tuple != null) {
            return tuple.toString();
        }
        else
            return colorName;
    }
}
