package pipe.gui.graphicElements.cpn;

import dk.aau.cs.gui.Context;
import dk.aau.cs.model.tapn.*;
import dk.aau.cs.model.tapn.Colored.*;
import dk.aau.cs.model.tapn.Colored.Color;
import dk.aau.cs.model.tapn.Colored.Expressions.*;
import pipe.dataLayer.NetType;
import pipe.gui.CreateGui;
import pipe.gui.Pipe;
import pipe.gui.graphicElements.PlaceTransitionObject;
import pipe.gui.graphicElements.tapn.TimedInputArcComponent;
import pipe.gui.widgets.ColoredArcDialogPanel;
import pipe.gui.widgets.EscapableDialog;
import pipe.gui.widgets.GuardDialogue;

import javax.swing.*;
import java.awt.*;
import java.util.Vector;

public class ColoredInputArcComponent extends TimedInputArcComponent {

    private ArcExpression expression;

    public ColoredInputArcComponent(PlaceTransitionObject newSource, ArcExpression expressionInput){
        this(new ColoredOutputArcComponent(newSource, expressionInput));
    }

    public ColoredInputArcComponent(ColoredOutputArcComponent arc){
        super(arc);
        expression = arc.getExpression();
    }

    public ColoredInputArcComponent(ColoredOutputArcComponent arc, String guard) {
        super(arc, guard);
        expression = arc.getExpression();
    }

    public ColoredInputArcComponent(PlaceTransitionObject source) {
        super(source);

       // NumberOfExpression expr = new NumberOfExpression(1, vector);
    }

    public ArcExpression getArcExpression() {
        return expression;
    }

    // hacks - I use the weight to display the TimeInterval
    @SuppressWarnings("Duplicates")
    @Override
    public void updateLabel(boolean showConstantNames) {
        //If there is no model we can't set the labels
        if(CreateGui.getModel() == null) {
            return;
        }
        if (!CreateGui.getModel().netType().equals(NetType.UNTIMED)) {
            String expressionString = "";
            if (inputArc == null)
                label.setText("");
            else {
                if (((ColoredInputArc)inputArc).getArcExpression() != null) {
                    expressionString = ((ColoredInputArc)inputArc).getArcExpression().toString();
                }
                if (!CreateGui.getApp().showZeroToInfinityIntervals()) {
                    if (inputArc.interval().toString(showConstantNames).equals("[0,inf)")){
                        label.setText(expressionString);
                    }
                    else {
                        label.setText(inputArc.interval().toString(showConstantNames) + "\n" + expressionString);
                    }
                }
                else {
                    label.setText(inputArc.interval().toString(showConstantNames)  + "\n" + expressionString);
                }

                label.setText(getWeight().toString(showConstantNames)+" "+label.getText());

                // Handle constant highlighting
                boolean focusedConstant = false;
                if(inputArc.interval().lowerBound() instanceof ConstantBound){
                    if(((ConstantBound) inputArc.interval().lowerBound()).constant().hasFocus()){
                        focusedConstant = true;
                    }
                }
                if(inputArc.interval().upperBound() instanceof ConstantBound){
                    if(((ConstantBound) inputArc.interval().upperBound()).constant().hasFocus()){
                        focusedConstant = true;
                    }
                }
                if(getWeight() instanceof ConstantWeight){
                    if(((ConstantWeight) getWeight()).constant().hasFocus()){
                        focusedConstant = true;
                    }
                }
                if(focusedConstant){
                    label.setForeground(Pipe.SELECTION_TEXT_COLOUR);
                }else{
                    label.setForeground(Pipe.ELEMENT_TEXT_COLOUR);
                }

            }
            this.setLabelPosition();
        }
    }

    @Override
    public void showTimeIntervalEditor() {
        EscapableDialog guiDialog = new EscapableDialog(CreateGui.getApp(), "Edit Arc", true);

        Container contentPane = guiDialog.getContentPane();

        // 1 Set layout
        contentPane.setLayout(new BoxLayout(contentPane, BoxLayout.PAGE_AXIS));

        // 2 Add Place editor
        contentPane.add(new ColoredArcDialogPanel(guiDialog.getRootPane(), this, new Context(CreateGui.getCurrentTab())));

        guiDialog.setResizable(false);

        // Make window fit contents' preferred size
        guiDialog.pack();

        // Move window to the middle of the screen
        guiDialog.setLocationRelativeTo(null);
        guiDialog.setVisible(true);
    }
}
